## sigx 2.0.2

=== SConstruct ===
# -*- python -*-
# SConstruct
# libsigx build script
#
# Process this file with 'scons' to build the project.
# For more information, please visit: http://www.scons.org/ .
#
# Usage:
#
#   . scons               build the library
#   . scons -h            see available configuration options
#   . scons opt=value     set a configuration option
#   . scons install       install library and include files (as root)
#   . scons tests				build test programs
#   . scons examples		build example programs
#   . scons dist          build a source package (.tar.bz2)
##   . scons docs          build documentation for the project (Doxygen)
#   . scons debian        help building a debian package, read and change the SConscript file in the debian/ directory!
#   . scons -c            clean intermediate files
#   . scons -c distclean  clean all target files
#


# scons version >0.98 is required, we need the NoClean function (0.97) and the AddMethod function (0.98)
EnsureSConsVersion(0, 98)

#import commands
import os, sys, re, string, glob, SCons.Node.FS

SConsignFile()


def Check_cxx_shared_ptr(context):
	context.Message('Checking for std::tr1::shared_ptr ...')
	ret = context.TryCompile("""
#include <tr1/memory>
int main()
{
	std::tr1::shared_ptr<int> p(new int(42));
	return 0;
}
""", '.cpp')
	context.Result(ret)
	return ret


subst_dict = { }
config_subst_dict = { }


#############
#  Options  #
#############

# explicit Command line options
opts = Options('options.cache')

opts.AddOptions(
	('DESTDIR', 'Destination root directory (useful for package maintainers)', ''), 
	PathOption('PREFIX', 'Installation prefix directory', '/usr/local'), 
	BoolOption('DEBUG', 'Debug version (useful for developers only)', 0), 
	BoolOption('SHAREDLIB', 'build a shared library, otherwise a static library', 1), 
	("TR1_INCLUDE_PATH", "Include path for c++ tr1\n(if your compiler has no tr1 or tr1 isn't in the standard include path)"), 
	("BOOST_INCLUDE_PATH", "Include path for c++ boost\nif boost isn't in the standard include path)")
)

###############################
#  Configuration Environment  #
###############################

# pull the whole environment in as construction variables;
# this allows us to get various environment variables like CXX, CXXFLAGS
construction_vars = os.environ.copy()
# ... and update the construction variables with explicitly specified arguments
construction_vars.update(**ARGUMENTS)

env = Environment(options = opts, tools = ['default', 'versionedlibrary', 'symlink'], ENV = os.environ, **dict(construction_vars))

if env.has_key('TR1_INCLUDE_PATH'):
	env.Append(CPPPATH = env['TR1_INCLUDE_PATH'])
if env.has_key('BOOST_INCLUDE_PATH'):
	env.Append(CPPPATH = env['BOOST_INCLUDE_PATH'])



# don't configure when cleaning
if not env.GetOption('clean'):
	conf = Configure(env, custom_tests = { 'Check_cxx_shared_ptr' : Check_cxx_shared_ptr })
	env.Append(SIGX_HAVE_CXX_SHARED_PTR = conf.Check_cxx_shared_ptr())
	env.Append(SIGX_HAVE_BOOST = conf.CheckCXXHeader('boost/mpl/eval_if.hpp'))
	if not env['SIGX_HAVE_CXX_SHARED_PTR']:
		print '<tr1/memory> header not found'
		Exit(1)
	if not env['SIGX_HAVE_BOOST']:
		print 'boost not found'
		Exit(1)
	env = conf.Finish()


# remember whether user called: scons -c distclean
if 'distclean' in COMMAND_LINE_TARGETS:
	do_distclean = True
else:
	do_distclean = False


env.Append(MAJOR='2', MINOR='0', MICRO='1')
env.Append(PACKAGE_NAME = 'sigx')
env.Append(VERSIONED_NAME = "%s-%s.%s" % (env['PACKAGE_NAME'], env['MAJOR'], env['MINOR']))

env.Append(CPPPATH = [ '#' ])

#env.Append(TARFLAGS = ['-c'])
#env.Append(TARFLAGS = ['--bzip2'])

# convert CXXFLAGS to an array because we append flags to it using lists
if env.has_key('CXXFLAGS') and type(env['CXXFLAGS']) == str:
	env['CXXFLAGS'] = env['CXXFLAGS'].split(' ');

if env['DEBUG'] == 1:
	env.Append(CXXFLAGS = ['-g'])
	env.Append(CXXFLAGS = ['-O0'])
	env.Append(CXXFLAGS = ['-W'])
	env.Append(CXXFLAGS = ['-Wall'])
	env.Append(CXXFLAGS = ['-ansi'])
	env.Append(CXXFLAGS = ['-pedantic'])
	env.Append(CXXFLAGS = ['-Wpointer-arith'])
	env.Append(CXXFLAGS = ['-Woverloaded-virtual'])
	env.Append(CXXFLAGS = ['-Wconversion'])
	env.Append(CXXFLAGS = ['-Wcast-align'])
	env.Append(CXXFLAGS = ['-Wshadow'])
else:
	env.Append(CXXFLAGS = ['-O2'])
	env.Append(CXXFLAGS = ['-DG_DISABLE_ASSERT=1'])
	#-fomit-frame-pointer -fmove-all-movables -fstrict-aliasing

# lib dependencies.
# we do depend on sigc-2.0 and glibmm;
# note that sigc is included in glibmm
env.ParseConfig ('pkg-config --cflags --libs glibmm-2.4')

# Generate help text for command line options
Help(opts.GenerateHelpText(env))

# Cache current options
opts.Save('options.cache', env)


##############
#  Builders  #
##############

def do_subst_in_file(targetfile, sourcefile, dict):
        """Replace all instances of the keys of dict with their values.
        For example, if dict is {'%VERSION%': '1.2345', '%BASE%': 'MyProg'},
        then all instances of %VERSION% in the file will be replaced with 1.2345 etc.
        """
        try:
            f = open(sourcefile, 'rb')
            contents = f.read()
            f.close()
        except:
            raise SCons.Errors.UserError, "Can't read source file %s"%sourcefile
        for (k,v) in dict.items():
            contents = re.sub(k, v, contents)
        try:
            f = open(targetfile, 'wb')
            f.write(contents)
            f.close()
        except:
            raise SCons.Errors.UserError, "Can't write target file %s"%targetfile
        return 0 # success
 
def subst_in_file(target, source, env):
        if not env.has_key('SUBST_DICT'):
            raise SCons.Errors.UserError, "SubstInFile requires SUBST_DICT to be set."
        d = dict(env['SUBST_DICT']) # copy it
        for (k,v) in d.items():
            if callable(v):
                d[k] = env.subst(v())
            elif SCons.Util.is_String(v):
                d[k]=env.subst(v)
            else:
                raise SCons.Errors.UserError, "SubstInFile: key %s: %s must be a string or callable"%(k, repr(v))
        for (t,s) in zip(target, source):
            return do_subst_in_file(str(t), str(s), d)
 
def subst_in_file_string(target, source, env):
        """This is what gets printed on the console."""
        return '\n'.join(['Substituting vars from %s into %s'%(str(s), str(t))
                          for (t,s) in zip(target, source)])
 
def subst_emitter(target, source, env):
        """Add dependency from substituted SUBST_DICT to target.
        Returns original target, source tuple unchanged.
        """
        d = env['SUBST_DICT'].copy() # copy it
        for (k,v) in d.items():
            if callable(v):
                d[k] = env.subst(v())
            elif SCons.Util.is_String(v):
                d[k]=env.subst(v)
        Depends(target, SCons.Node.Python.Value(d))
        # Depends(target, source) # this doesn't help the install-sapphire-linux.sh problem
        return target, source
 
subst_action = Action (subst_in_file, subst_in_file_string)
subst_builder = Builder(action=subst_action, emitter=subst_emitter)
env.Append (BUILDERS = {'SubstInFile' : subst_builder})


#
# source tar file builder
#

def distcopy (target, source, env):
    treedir = str (target[0])

    try:
        os.mkdir (treedir)
    except OSError, (errnum, strerror):
        if errnum != errno.EEXIST:
            print 'mkdir ', treedir, ':', strerror

    cmd = 'tar cf - '
    #
    # we don't know what characters might be in the file names
    # so quote them all before passing them to the shell
    #
    all_files = ([ str(s) for s in source ])
    cmd += " ".join ([ "'%s'" % quoted for quoted in all_files])
    cmd += ' | (cd ' + treedir + ' && tar xf -)'
    p = os.popen (cmd)
    return p.close ();

def tarballer (target, source, env):            
    cmd = 'tar cjf ' + str (target[0]) +  ' ' + str(source[0]) + "  --exclude-from='sigx_tar_exclude_these_files.txt'"
    print 'running ', cmd, ' ... '
    p = os.popen (cmd)
    return p.close ()

dist_bld = Builder (action = distcopy,
                    target_factory = SCons.Node.FS.default_fs.Entry,
                    source_factory = SCons.Node.FS.default_fs.Entry,
                    multi = 1)

tarball_bld = Builder (action = tarballer,
                       target_factory = SCons.Node.FS.default_fs.Entry,
                       source_factory = SCons.Node.FS.default_fs.Entry)

env.Append (BUILDERS = {'Distribute' : dist_bld})
env.Append (BUILDERS = {'Tarball' : tarball_bld})

# Documentation generation system
doxygen_builder = Builder(action = 'doxygen $SOURCE')
env.Append(BUILDERS = { 'DoxygenDoc' : doxygen_builder })

# M4 builder
# note that scons has a built-in m4 builder but I define here my own because 
# the built-in one feeds sigx's m4 files through stdin which produces the wrong
# header file guard

m4_builder = Builder(action = 'm4 -Imacros $SOURCE > $TARGET')
env.Append(BUILDERS = { 'M4' : m4_builder })

########################
#  Installation rules  #
########################

env.Append(INSTALL_PREFIX = env['DESTDIR'] + env['PREFIX'])
env.Append(LIBDIR = "%s/lib" % env['INSTALL_PREFIX'])
env.Append(LIBINCLUDEDIR = "%s/lib/%s/" % (env['INSTALL_PREFIX'], env['VERSIONED_NAME']))
env.Append(INCLUDEDIR = "%s/include/%s/sigx" % (env['INSTALL_PREFIX'], env['VERSIONED_NAME']))

installpaths = [ env['LIBDIR'], env['LIBINCLUDEDIR'], env['INCLUDEDIR'] ]



###########################
#  Configuration summary  #
###########################

debugging = ""

if env['DEBUG']:
	debugging = "ON"
else:
	debugging = "OFF"

libtype = ""

if env['SHAREDLIB']:
	libtype = "shared"
else:
	libtype = "static"



print ""
print "+=================+"
print "|  CONFIGURATION  |"
print "+=================+"
print ""
print "Installation prefix      : " + env['PREFIX']
print "libdir                   : " + env['LIBDIR']
print "libincludedir            : " + env['LIBINCLUDEDIR']
print "includedir               : " + env['INCLUDEDIR']
print "Debugging mode           : " + debugging
if env.has_key('TR1_INCLUDE_PATH'):
	print "tr1 include path         : " + env['TR1_INCLUDE_PATH']
if env.has_key('BOOST_INCLUDE_PATH'):
	print "boost include path       : " + env['BOOST_INCLUDE_PATH']
print "Library                  : " + libtype
print "c++ compiler             : " + env['CXX']
print ""



#################
#  Build rules  #
#################

# generate templates


# Build directory
if env['DEBUG']:
	BuildDir("#build/debug", 'src', duplicate = 0)
	buildDirectory = 'build/debug/'
else:
	BuildDir("#build/release", 'src', duplicate = 0)
	buildDirectory = 'build/release/'

# remember build directory for SConscript files
env['BUILDDIR'] = buildDirectory

Export('env')




#########################
#  Generate sigx.pc  #
#########################

subst_dict['%MAJOR%'] = env['MAJOR']
subst_dict['%MINOR%'] = env['MINOR']
subst_dict['%MICRO%'] = env['MICRO']
subst_dict['%PREFIX%'] = env['PREFIX']
subst_dict['%VERSIONED_NAME%'] = env['VERSIONED_NAME']

pcfilename =  "%s.pc" % env['VERSIONED_NAME']
pcbuild = env.SubstInFile ( pcfilename,'sigx.pc.in', SUBST_DICT = subst_dict)


###############################
#  Generate sigxconfig.h  #
###############################

# substitute certain defines sin sigxconfig.h.in
#config_subst_dict['#undef SIGX_HAVE_XYZ'] = '#define SIGX_HAVE_XYZ 1';

configbuild = env.SubstInFile('sigxconfig.h', 'sigxconfig.h.in', SUBST_DICT = config_subst_dict)




###################
#  Documentation  #
##################

#subst_dict['%TOP_SRCDIR%'] = env['ENV']['PWD']
doxybuild = env.SubstInFile ( 'docs/Doxyfile', 'docs/Doxyfile.in', SUBST_DICT = subst_dict)

doxygen_path = '(doxygen-generated-files)'
env.DoxygenDoc(doxygen_path, 'docs/Doxyfile')


#######################
#  build and targets  #
#######################

m4build = SConscript(os.path.join('macros', 'SConscript'))
sigxbuild = SConscript(os.path.join(buildDirectory, 'SConscript'))

=== debian/changelog ===
sigx (2.0.2-5ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 04 Aug 2015 11:40:15 +0100

sigx (2.0.2-5) unstable; urgency=medium

  * [bba6d8a] Update watch file
  * [212c2eb] Add missing dependency on libjs-jquery

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 24 May 2015 10:39:53 +0800

sigx (2.0.2-4) unstable; urgency=medium

  * [e9b4c01] Amend pkgconfig for multiarch lib paths (LP: #1457467)
  * [f8ecb20] Don't include DESTDIR in LIBDIR override
  * [bd9bb8f] Bump Standards-Version to 3.9.6
  * [98ee423] Don't install bundled jquery.js

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 23 May 2015 02:32:47 +0800

sigx (2.0.2-3) unstable; urgency=low

  * [8fd8898] Update homepage
  * [0eecdf8] Bump Standards-Version to 3.9.4
  * [25dee45] Override LIBDIR for multiarch paths
  * [ea1e5e9] Update install files for multiarch paths
  * [ff9082e] Reexport patches using gbp-pq
  * [49b0029] Patch SConstruct to not blindly append to LIBDIR
  * [b1c5b05] Set CPPFLAGS
  * [3e2470f] Add Multi-Arch fields

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 01 Sep 2013 21:59:30 +0800

sigx (2.0.2-2) experimental; urgency=low

  * [b0e5a0e] Move to 3.0 (quilt) format
  * [84b3009] Patch to avoid including individual glib headers (Closes: #665611)
  * [a8e7d0e] Bump Standard-Version to 3.9.3
  * [967938e] Update debian/copyright to fit new copyright-format
  * [aa6892c] Update my email address
  * [893a08c] Include dpkg/default.mk for build flags
  * [85c2eb5] Fix up broken SHLINKFLAGS handling in scons

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 17 May 2012 13:52:31 +0800

sigx (2.0.2-1) unstable; urgency=low

  * Initial release (Closes: #492215)
  * Original .tar.bz2 tarball repackaged into .tar.gz, see debian/copyright
    and debian/rules for more details.

 -- Chow Loong Jin <hyperair@gmail.com>  Mon, 23 Mar 2009 05:19:42 +0800

=== debian/control ===
Source: sigx
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Chow Loong Jin <hyperair@debian.org>
Build-Depends: debhelper (>= 7.2),
               dpkg-dev (>= 1.16.1~),
               m4,
               scons,
               doxygen,
               libsigc++-2.0-dev,
               libgtkmm-2.4-dev,
               libglibmm-2.4-dev,
               libglib2.0-dev,
               libboost-dev
Standards-Version: 3.9.6
Vcs-Git: git://git.debian.org/git/collab-maint/sigx.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sigx.git
Homepage: http://triendl.info/sigx/

Package: libsigx-2.0-2v5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsigx-2.0-2
Replaces: libsigx-2.0-2
Description: interthread communication library for C++ - runtime
 This library is an interthread communication library for C++ on top of
 libsigc++ and glibmm. It provides dispatcher based interthread communication,
 typesafe functor adaptors to execute functions in the context of another
 thread, threadsafe wrappers for signals and connections, and deadlock detection
 for synchronous messages.
 .
 This package contains the runtime files for libsigx, needed if you wish to run
 or compile software which depends on it.

Package: libsigx-2.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libsigx-2.0-2v5 (= ${binary:Version}),
         pkg-config,
         libsigc++-2.0-dev,
         libglibmm-2.4-dev,
         libglib2.0-dev
Suggests: libsigx-2.0-doc
Description: interthread communication for C++ - development files
 This library is an interthread communication library for C++ on top of
 libsigc++ and glibmm. It provides dispatcher based interthread communication,
 typesafe functor adaptors to execute functions in the context of another
 thread, threadsafe wrappers for signals and connections, and deadlock detection
 for synchronous messages.
 .
 This package contains the development files for libsigx, needed only if you
 wish to write or compile software which uses it. 


Package: libsigx-2.0-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Recommends: libsigx-2.0-dev
Description: interthread communication for C++ - reference documentation
 This library is an interthread communication library for C++ on top of
 libsigc++ and glibmm. It provides dispatcher based interthread communication,
 typesafe functor adaptors to execute functions in the context of another
 thread, threadsafe wrappers for signals and connections, and deadlock detection
 for synchronous messages.
 .
 This package contains the reference documentation for libsigx, needed only if
 you wish to write software which uses it.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/default.mk

DEBIAN_DIR := $(dir $(firstword $(MAKEFILE_LIST)))
SCONS = scons --directory $(DEB_BUILDDIR) CFLAGS="$(CFLAGS)" CXXFLAGS="$(CXXFLAGS)" CPPFLAGS="$(CPPFLAGS)" SHLINKFLAGS="$(LDFLAGS)"
SCONS_OPTS =										\
	DESTDIR="$(CURDIR)/debian/tmp/"							\
	PREFIX=/usr									\
	LIBDIR=/usr/lib/$(DEB_HOST_MULTIARCH)

get-orig-source:
	uscan --destdir $(CURDIR) \
	      --watchfile $(DEBIAN_DIR)/watch \
		  --repack \
		  --rename \
		  --force-download

override_dh_auto_clean:
	scons --keep-going --clean distclean || true
	rm -rf docs/html \
	       options.cache \
		   .sconsign.dblite \
		   site_scons/site_tools/*.pyc

override_dh_auto_build:
	$(SCONS) $(SCONS_OPTS)
	$(SCONS) docs $(SCONS_OPTS)

override_dh_auto_install:
	$(SCONS) install $(SCONS_OPTS)

override_dh_installdocs:
	dh_installdocs -X jquery.js

%:
	dh $@

=== debian/watch ===
version=3

http://triendl.eu/sigx/ sigx-(.*)\.tar\.bz2
